Texture2D heightTexture;
SamplerState heightTextureSampler;

cbuffer NormalLevelParameters
{
  float4x4 projectionMatrix;
  float2 oneOverHeightMapSize;

  float heightExaggeration;
  float postDelta;
};

struct VertexIn
{
  float4 Position : SV_Position;
  float2 TextureCoordinates : TEXCOORD0;
};

float4 main(VertexIn In) : SV_Target
{
  float top = heightTexture.Sample(heightTextureSampler, In.TextureCoordinates + float2(0.0, oneOverHeightMapSize.y)).r * heightExaggeration;
  float bottom = heightTexture.Sample(heightTextureSampler, In.TextureCoordinates + float2(0.0, -oneOverHeightMapSize.y)).r * heightExaggeration;
  float left = heightTexture.Sample(heightTextureSampler, In.TextureCoordinates + float2(-oneOverHeightMapSize.x, 0.0)).r * heightExaggeration;
  float right = heightTexture.Sample(heightTextureSampler, In.TextureCoordinates + float2(oneOverHeightMapSize.x, 0.0)).r * heightExaggeration;

  float4 normal = float4(normalize(float3(left - right, top - bottom, 1.0 * postDelta)), 1.0);

  return normal;
}
